# Enterprise Customers Endpoints for enterprise-level customer management. ## List enterprise customers - [GET /v1/enterprise-customers](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/getv1enterprisecustomers.md): List of all or filtered customers defined at the enterprise level ## Create enterprise customer - [POST /v1/enterprise-customers](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/postv1enterprisecustomers.md): The customer will be available in all branches. The customer data must be added through the payload attribute "customfields". Each kind of data associated with a customer is a custom filed. For example: firstName, lastName, email etc. You can use the endpoint GET /customers/customfields to retrieve all available custom fields for the selected company. To create a new custom field you can use the endpoint POST customers/customfields ## List enterprise custom fields - [GET /v1/enterprise-customers/customfields](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/getv1enterprisecustomerscustomfields.md): List custom field definitions for enterprise customers. ## Create enterprise custom field - [POST /v1/enterprise-customers/customfields](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/postv1enterprisecustomerscustomfields.md): All new custom fields are available to all customers. ## List enterprise custom field categories - [GET /v1/enterprise-customers/customfields/categories](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/getv1enterprisecustomerscustomfieldscategories.md): List categories that group enterprise customer custom fields. ## Create enterprise custom fields category - [POST /v1/enterprise-customers/customfields/categories](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/postv1enterprisecustomerscustomfieldscategories.md): Create a custom field category for enterprise customers. ## Delete enterprise custom fields category - [DELETE /v1/enterprise-customers/customfields/categories/{categoryId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/deletev1enterprisecustomerscustomfieldscategoriesbycategoryid.md): Delete an enterprise customer custom field category. ## Fetch enterprise custom field category - [GET /v1/enterprise-customers/customfields/categories/{categoryId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/getv1enterprisecustomerscustomfieldscategoriesbycategoryid.md): Fetch a single enterprise customer custom field category. ## Update enterprise custom fields category - [PATCH /v1/enterprise-customers/customfields/categories/{categoryId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/patchv1enterprisecustomerscustomfieldscategoriesbycategoryid.md): Update an enterprise customer custom field category. ## Delete enterprise custom field - [DELETE /v1/enterprise-customers/customfields/{fieldId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/deletev1enterprisecustomerscustomfieldsbyfieldid.md): Delete an enterprise customer custom field definition. ## Fetch enterprise customer field - [GET /v1/enterprise-customers/customfields/{fieldId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/getv1enterprisecustomerscustomfieldsbyfieldid.md): Fetch a single enterprise customer custom field definition. ## Update enterprise custom field - [PATCH /v1/enterprise-customers/customfields/{fieldId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/patchv1enterprisecustomerscustomfieldsbyfieldid.md): Each custom field is a data field for every customer. For example: firstName, lastName etc. With this endpoint, you can create your own custom fields like customerNr. ## Post import - [POST /v1/enterprise-customers/import](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/postv1enterprisecustomersimport.md): Bulk import or update enterprise customers. ## Delete enterprise customer - [DELETE /v1/enterprise-customers/{customerId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/deletev1enterprisecustomersbycustomerid.md): Delete a customer with the "customerId" or "externalId" parameter ## Fetch enterprise customer - [GET /v1/enterprise-customers/{customerId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/getv1enterprisecustomersbycustomerid.md): The URL parameter "customerId" can be used in two ways: - Unique ID of the customer assigned by TIMIFY ("customerId"). In this case, you don't need the QUERY parameter "external" - use the "externalId" that you added to this customer. In this case, you need to add the parameter "external" ( for ex.: /?external=1) so the api will search by your "externalId" and not by "customerId" assigned by TIMIFY You can add "externalId" to the customer with the endpoints POST /customers and PATCH customers/:customerId ## Update enterprise customer - [PATCH /v1/enterprise-customers/{customerId}](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/patchv1enterprisecustomersbycustomerid.md): Update the data of a customer. Customer data is created and updated with the "customfield" attribute. Every data attribute of a customer is a custom field, for example firstName, lastName, email etc. The URL parameter "customerId" can be used in two ways: - As a unique ID of the customer assigned by TIMIFY ("customerId"). In this case, you don't need the QUERY parameter "external" - use the "externalId" that you added to this customer. In this case, you need to add the parameter "external" ( for ex.: /?external=1) the API will search by your "externalId" and not by "customerId" assigned by TIMIFY You can add "externalId" to the customer with the Developer API endpoints POST /customers and PATCH /customers/:customerId You can use the endpoint GET /customers/customfields to retrieve all available custom fields for the selected company. To create a new custom field you can use the endpoint POST /customers/customfields ## List customer events - [GET /v1/enterprise-customers/{customerId}/events](https://timify-dev-api.redocly.app/apis/openapi/enterprise-customers/getv1enterprisecustomersbycustomeridevents.md): List customer events